unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Process, Registry,
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  AsyncProcess, ValEdit, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    VLE: TValueListEditor;
    procedure FormCreate(Sender: TObject);
    procedure VLEDblClick(Sender: TObject);
  private
    procedure getApps();
    procedure runAppx(AppID: string);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  getApps;
end;

procedure TForm1.VLEDblClick(Sender: TObject);
begin
  RunAppX(VLE.Values[VLE.Keys[VLE.Row]]);
end;

procedure TForm1.getApps;
var
  Reg: TRegistry;
  sl: TStringList;
  i: integer;
  s: string;
begin
  sl := TStringList.Create;
  Reg := TRegistry.Create;

  if Reg.OpenKeyReadOnly('Software\Classes') then
  begin
    //alle Schlüssel unterhalb classes in sl eintragen
    Reg.GetKeyNames(sl);

    //Alle nicht-AppX löschen
    for i := sl.Count - 1 downto 0 do
    begin
      if Pos('AppX', sl.Strings[i]) <> 1 then
        sl.Delete(i);
    end;

    //Alle Schlüssel und IDs in Liste eintragen
    for i := 0 to sl.Count - 1 do
    begin
      s := '\Software\Classes\' + sl.Strings[i] + '\Application';
      if Reg.OpenKeyReadOnly(s) then
        VLE.InsertRow(Reg.ReadString('ApplicationName'),
          Reg.ReadString('AppUserModelID'), True);
    end;
  end;

  sl.Free;
  Reg.Free;
end;

procedure TForm1.runAppx(AppID: string);
var
  aProcess: TAsyncProcess;
begin
  aProcess := TAsyncProcess.Create(nil);
  aProcess.Options := [poNoConsole, poStderrToOutPut];
  aProcess.Executable := 'explorer.exe';
  aProcess.Parameters.Append('shell:AppsFolder\' + AppID);
  try
    aProcess.Execute;
  finally
    aProcess.Free;
  end;
end;

end.
